<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: index.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: index.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>#!/usr/bin/env node

// Imports and check all dependency modules
require("./_check_imports");
const M = {
  chalk: require("chalk"),
  path: require("path"),
  Menu: require("./menu"),
  Scaffold: require("./scaffold")
};

const SCAFFOLD_DEFAULT_DIR = "./scaffold";

/**
 * The magic of scaffolding
 *
 * ### Create the structure
 *
 * Run: `scavader init -d scaffold/`
 *
 * ### Example of usage
 * You can either use the CLI to launch a scaffold
 * or you can use a script.
 *
 * #### CLI
 *
 * ```
 * scavader init -d scaffold
 * scavader run -d scaffold -q questions
 * ```
 *
 * #### Script
 * ```
 * Scavader = require("scavader")
 *
 * let scavader = new Scavader("./scaffold.example/", "Scavader");
 *
 * scavader.run("questions").then(result => {
 *   console.log(result);
 * });
 * ```
 *
 * ### Configuration object
 *
 * | Field name | Description |
 * |------------|-------------|
 * | scaffoldQuestionDir | Overrides the subdirectory path of questions (default: 'questions/') |
 * | scaffoldCommandsDir | Overrides the subdirectory path of questions (default: 'commands/') |
 *
 * @see module:menu
 * @see module:scaffold
 */
class Scavader {
  /**
   * Create a Scavader instance.
   * @param {string} scaffoldDir The directory of the scaffold commands and questions (default: 'scaffold')
   * @param {string} title The title to be displayed when running the menu of questions.
   * @param {object} config A configuration object that let you overrides some internal values.
   */
  constructor(scaffoldDir = SCAFFOLD_DEFAULT_DIR, title = "Scavader", config) {
    this.scaffoldDir = scaffoldDir;
    this.config = Object.assign(
      {
        scaffoldQuestionsDir: "questions/", // Scaffold questions subdirectory path to be override
        scaffoldCommandsDir: "commands/" // Scaffold commands subdirectory path to be overrid
      },
      config
    );

    this.Menu = new M.Menu(title);
    this.Scaffold = new M.Scaffold(
      `${this.scaffoldDir}/${this.config.scaffoldCommandsDir}/`
    );
  }

  /**
   * Run a sequence of questions and returns a promise that will resolves
   * returning the answers
   * @param {array} questionModule An array of question to be asked
   * @return {Promise} The promise that resolves the answers
   */
  run(questionsFile) {
    return new Promise((resolve, reject) => {
      let questionPath =
        process.cwd() +
        "/" +
        M.path.normalize(
          `${this.scaffoldDir}/${
            this.config.scaffoldQuestionsDir
          }/${questionsFile}`
        );
      try {
        let questionsFile = require(questionPath);
        this.Menu.run(questionsFile).then(resultsMenu => {
          let scaffolds = this._transformQuestionsResultToScaffold(resultsMenu);
          this.Scaffold.run(scaffolds).then(resultScaffold => {
            resolve(resultScaffold);
          });
        });
      } catch (e) {
        console.error(
          M.chalk.red(
            `ERROR: Scavager could not load or execute the questions file (path=${questionPath})`
          )
        );
        reject(e);
      }
    });
  }

  /**
   * Transforms the result of the menu to be used by the scaffold command
   * exectuer.
   */
  _transformQuestionsResultToScaffold(resultsMenu) {
    return resultsMenu.map(result => {
      return {
        name: result.question.name,
        command: result.question.command,
        value: result.value
      };
    });
  }
}

if (require.main === module) {
  const CLI = require("./cli");
  CLI(Scavader, SCAFFOLD_DEFAULT_DIR);
} else {
  module.exports = Scavader;
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-menu.html">menu</a></li><li><a href="module-scaffold.html">scaffold</a></li></ul><h3>Classes</h3><ul><li><a href="Scavader.html">Scavader</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.2</a> on Wed Jun 12 2019 17:39:45 GMT+0100 (GMT+01:00)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
